<?php
/***************************************************************************
 *                            admin_ezconvert.php
 *                            -------------------
 *   $Id: admin_ezconvert.php,v 1.7 2004/07/29 17:39:57 draknek Exp $
 *   begin                : Sunday, 22 July 2002
 *   author               : Rob Bellaart
 *   email                : bellaart@ghanaweb.com
 *
 *   modified             : Monday, 13 January 2003
 *   author               : Chris Burke
 *   email                : serotonin@earthlink.net
 *
 *   modified             : Monday, 07 July 2003
 *   author               : Jamie Tatum
 *   email                : jt@killsdead.com
 *
 *   modified             : Saturday, 19 June 2004
 *   author               : Alan Hazelden (Draknek)
 *   email                : ezconvert@draknek.org
 *
 *   purpose              : converts an ezboard forum to a phpbb format
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Conversion']['EZConvert'] = $file;
    $module['Conversion']['EZConvert_Manual'] = './ezconvert/readme.htm';
	return;
}

define('IN_PHPBB', true);

$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
$no_page_header = true;
require ('./pagestart.' . $phpEx);

$ezconvert_dir = './ezconvert/';
include ($ezconvert_dir . 'config.' . $phpEx);

$stages = array(
    'Set up/Confirm configuration options',
    'Creating topics',
    'Creating posts',
    'Reordering posts into correct order',
    'Fixing relationships between topics and posts',
    'Correcting/Guessing information about users',
    'Complete',
);

$stage = $_GET['stage'];
$stage = isset($stages[$stage]) ? $stage : 0;
$stage_name = $stages[$stage];

?>
<html>
<head>
  <title>ezBoard to phpBB conversion - <?=$stage_name?></title>
  <style type="text/css">
    .error {
      color: #FF0000;
      font-size: 150%;
      font-weight: bold;
    }
  </style>
</head>
<body>
  <h2>ezBoard to phpBB conversion - <?=$stage_name?></h2>

<?php

$start_time = time ();

if (file_exists($ezconvert_dir . 'stage_' . $stage . '.' . $phpEx))
     include($ezconvert_dir . 'stage_' . $stage . '.' . $phpEx);
else fatal_error('Cannot find file stage_' . $stage . '.' . $phpEx);

// Prints a message
function notice ($message, $force = false)
{
    global $config;
    if ($force or ($config['debug_level'] > 0))
       echo '<h3>Notice: ' . $message . "</h3>\n";
}

function warning ($message)
{
    $message = '<div class="error">Warning: ' . $message . "</div>\n";
    echo $message;
}

// Logs an error message in case of a fatal error
function fatal_error ($message)
{
    $message = '<div class="error">Error: ' . $message . "</div>\n";
    die ($message);
}

// Executes a SQL command with error handling
function exec_sql ($sql, $transaction = FALSE)
{
    global $db, $config;
    if ($config['debug_level'] > 1)
         echo '<h5>SQL: ' . htmlspecialchars($sql) . "</h5>\n";
    if (!$result = $db->sql_query($sql, $transaction))
    {
        @$sql_error = $db->sql_error();
        fatal_error ('Database error<br />SQL code: ' . htmlspecialchars($sql) .
                     '<br />SQL Error: ' . $sql_error['message']);
    }
    return ($result);
}

// Forces a reload of the page
function reload ()
{ global $stage;
  ?>
  This run of stage <?=$stage?> is complete. You may need to click
  <a href="<?=append_sid(basename(__FILE__).'?stage='.$stage)?>">HERE</a>
  if your browser does not automatically refresh.
  <script language="Javascript" type="text/javascript">
    <!--
    document.location.reload();
    //-->
  </script>
<?php
}

function next_stage ()
{
    global $stage;
    $message = 'Stage ' . $stage . ' completed. <a href="';
    $message .= append_sid(basename(__FILE__) . '?stage=' . ($stage+1));
    $message .= '">Click here</a> to continue to the next stage.';
    notice($message,true);
}

// Checks whether the allotted execution time of the script has been exceeded
function check_execution_time ()
{
     global $max_execution_time, $start_time;
     
     if ( $start_time + $max_execution_time > time() )
     {
        return true;
     }
     return false;
}

// Determines whether a given table exists.
function table_exists($table)
{
    global $db;
    $sql = 'SELECT COUNT(*) FROM ' . $table;
    if ( !($result = $db->sql_query($sql)) )
        return false;
    if ( $row = $db->sql_fetchrow($result) )
        return true;
    return false;
}

?>
</body>
</html>
