<?php
/***************************************************************************
 *                                config.php
 *                            -------------------
 *   $Id: config.php,v 1.14 2005/01/25 23:56:51 draknek Exp $
 *   begin                : Thursday, 29 July 2004
 *   author               : Alan Hazelden (Draknek)
 *   email                : ezconvert@draknek.org
 *
 *   purpose              : set up configuration for EZConvert
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// Include EZConvert files
include ($ezconvert_dir . 'ezboard-parse.' . $phpEx);
include ($ezconvert_dir . 'phpbb-insert.' . $phpEx);

// Include phpBB files
// Draknek can't see where this one is used
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);

// Define constants
define('EZBOARD_CONVERSION', $table_prefix . 'ezboard_conversion');
define('EZCONVERT_CONFIG_TABLE', $table_prefix . 'ezboard_config');
define('EZCONVERT_CURRENT_TABLE_SCHEMA', 1);

// Try to increase maximum execution time, just in case
$change = 120;
$default = ini_get ('max_execution_time');
if ($default < $change and (@ini_set('max_execution_time',$change) === false))
     $current = $default;
else $current = $change;
$max_execution_time = (( $current / 3) + 1);
unset($change,$current,$default);

// Default config settings
$config = array(
    'ezboard_forum' => 'http://',
    'forum_id' => '',
    'default_pass' => '',
    'default_pass2' => '',
    'debug_level' => '1',
    'use_admin' => '0',
    'ezboard_user' => '',
    'ezboard_pass' => '',
    'connect_with' => 'fsockopen',
    'strip_html' => '0',
    'enable_sigs' => '0',
    'strip_crlf' => '1',
    'closeThreadImage' => '',
    'multiple_pages' => '0',
    'date_format' => 'mmdd',
    'timezone' => 'local',
    'user_create' => 'all',
	'ezboard_cookie' => '',
	'ezboard_cookie2' => '',
	'table_schema' => '0',
);

// Get configuration settings
if (table_exists(EZCONVERT_CONFIG_TABLE))
{
	$config2 = array();
	$sql = 'SELECT * FROM ' . EZCONVERT_CONFIG_TABLE;
	$result = exec_sql($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$name = $row['config_name'];
		$value = $row['config_value'];
		$config2[$name] = $value;
	}
	define('EZCONVERT_CONFIGURED', true);
}
else
{
    // Table doesn't exist, so create it
    $sql = 'CREATE TABLE ' . EZCONVERT_CONFIG_TABLE . ' ('.
           'config_name varchar(255) NOT NULL, '.
           'config_value varchar(255) NOT NULL )';
	exec_sql ($sql);
    notice('Table ' . EZCONVERT_CONFIG_TABLE . ' has been created.');
}

foreach ($config as $name => $value)
{
	if (isset($config2) && isset($config2[$name]))
	{
		$config[$name] = $config2[$name];
	}
	else
	{
		$value = str_replace("'", "''", $value);
		$sql = 'INSERT INTO ' . EZCONVERT_CONFIG_TABLE . " (config_name, config_value) VALUES ('$name', '$value')";
		exec_sql($sql);
	}
}

// Everything from the database is now in $config
unset($config2);

// Really hacky code - ezBoard's cookie is longer than our textfield, so we use two fields
$config['ezboard_cookie'] .= $config['ezboard_cookie2'];
unset($config['ezboard_cookie2']);

// Semi-hidden config options - no point keeping them in the database
$config['user_agent'] = 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)';
$config['login_page'] = 'http://beta.ezboard.com/BBSUser.authorizeUser';
$config['index_posts'] = '1';

function update_config ($config_change)
{
	global $config;

	foreach ($config_change as $name => $value)
	{
		$config[$name] = $value;

		$value = str_replace("'", "''", $value);
		$sql = 'UPDATE ' . EZCONVERT_CONFIG_TABLE . " SET config_value='$value' WHERE config_name='$name'";
		exec_sql($sql);
	}
}

?>
