<?php
/***************************************************************************
 *                             phpbb-insert.php
 *                            -------------------
 *   begin                : Wednesday, 20 August 2002
 *   author               : Rob Bellaart
 *   email                : bellaart@ghanaweb.com
 *
 *   modified             : Monday, 13 January 2003
 *   author               : Chris Burke
 *   email                : serotonin@earthlink.net
 *
 *   modified             : Monday, 07 July 2003
 *   author               : Jamie Tatum
 *   email                : jt@killsdead.com
 *
 *   modified             : Saturday, 19 June 2004
 *   author               : Alan Hazelden (Draknek)
 *   email                : ezconvert@draknek.org
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// Checks whether a user exists, and creates an account with default password if not
function convert_user ($user_name, $user_registered)
{
	global $db, $config;

	if (($config['user_create'] == 'none') or (($config['user_create'] == 'keepguests') and (!$user_registered)))
	{
		return -1;
	}

   // Added by Chris Burke based on code in phpBB registration script
   $user_name = str_replace('&nbsp;', '', $user_name);
   // End addition

   $user_name = substr($user_name, 0, 25); // name field is maximum 25 chars long

   $sql = "SELECT user_id FROM " . USERS_TABLE . " WHERE username='".str_replace("'", "''", $user_name)."'";
   $result = exec_sql ($sql);
   if ($row=$db->sql_fetchrow($result))
   {
	// User exists... (added comment CJB)
      $user_id=$row["user_id"];
   }
   else
   {
      $sql = "SELECT max(user_id) AS CNT FROM " . USERS_TABLE;
      $result = exec_sql ($sql);
      $row = $db->sql_fetchrow($result);
      $user_id=$row["CNT"]+1;
	// Modified by Chris Burke. This is anal, but matches the ordering and code in the registration
	// script better. Since registration seems to use email address as a key for detecting duplicate
	// registrations, we forge a unique email address.
//      $sql = "insert into ". USERS_TABLE . " (user_id, user_active, username, user_password, user_level) ".
//             "values ($user_id, '1', '".str_replace("'", "''", $user_name)."', '".md5($default_password)."', '0')";
//      exec_sql ($sql);
	$fake_email = $user_name . "@null.nul";
	$sql = "INSERT INTO ". USERS_TABLE . " (user_id, username, user_password, user_email, user_level, user_active) ".
		"VALUES ($user_id, '".str_replace("'", "''", $user_name)."', '".md5($config['default_pass'])."', '$fake_email', '0', '1' )";
	$result = exec_sql ($sql, BEGIN_TRANSACTION);
	// End modification

	// Added by Chris Burke to better mimic the registration script
	$sql = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user, group_moderator)
		VALUES ('', 'Personal User', 1, 0)";
	$result = exec_sql ($sql);
	$group_id = $db->sql_nextid();
	$sql = "INSERT INTO " . USER_GROUP_TABLE . " (user_id, group_id, user_pending)
		VALUES ($user_id, $group_id, 0)";
	$result = exec_sql ($sql, END_TRANSACTION);
	// End of addition
    }
   return ($user_id);
}

// Saves the posting in the phpbb database if it is not already present
//
// Modified JT - If you enable smilies AND have HTML on, ezboard peppers the
// HTML emoticons with the original emoticon text in the alt tag and comments
// phpBB ends up putting a link to the smiley image twice along with ezboard's link.
// You only get one smiliey but there's some messy html and a trailing "> in the post.
// Disable smilies in phpBB if html processing is on.
function convert_posting ($topicID, $index, $user_id, $user_name, $timestamp, $title, $text)
{
   global $db, $config;

   $forum_id = $config['forum_id'];

   $sql = "SELECT post_id FROM " . POSTS_TABLE . " WHERE forum_id=$forum_id AND topic_id=$topicID AND ".
          "post_time=$timestamp AND poster_id=$user_id";
   $result = exec_sql ($sql);
   if (!$row=$db->sql_fetchrow($result))
	{
		$enablesmilies = ($config['strip_html'] ? 1 : 0);
		$enablesigs = ($config['enable_sigs'] ? 1 : 0);

		$sql = 'INSERT INTO ' . POSTS_TABLE . ' (topic_id, forum_id, poster_id, post_username, post_time, enable_smilies, enable_sig) '.
			"VALUES ($topicID, $forum_id, $user_id, '".str_replace("'", "''", $user_name)."', $timestamp, $enablesmilies, $enablesigs)";

		exec_sql ($sql);

      $post_id = $db->sql_nextid();
      $sql = "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, post_subject, post_text) ".
             "VALUES ($post_id, '".str_replace("'", "''", $title)."', '".str_replace("'", "''", $text)."')";		// Bug fix for title - CJB
      exec_sql ($sql);
	  if ($config['index_posts'])
	  {
		  add_search_words('single', $post_id, $text, $title);
	  }
      if ($index == 0)
      {
         $sql = "UPDATE " . TOPICS_TABLE . " SET topic_first_post_id=$post_id, topic_poster=$user_id WHERE topic_id=$topicID AND forum_id=$forum_id";
         exec_sql ($sql);
      }
      $sql = "UPDATE " . TOPICS_TABLE . " SET topic_last_post_id=$post_id WHERE topic_id=$topicID AND forum_id=$forum_id AND topic_last_post_id <= $post_id";
      exec_sql ($sql);
   }
}

?>
