<?php
/***************************************************************************
 *                            admin_ezconvert.php
 *                            -------------------
 *   begin                : Sunday, 22 July 2002
 *   author               : Rob Bellaart
 *   email                : bellaart@ghanaweb.com
 *
 *   modified             : Monday, 13 January 2003
 *   author               : Chris Burke
 *   email                : serotonin@earthlink.net
 *
 *   modified             : Monday, 07 July 2003
 *   author               : Jamie Tatum
 *   email                : jt@killsdead.com
 *
 *   modified             : Saturday, 19 June 2004
 *   author               : Alan Hazelden (Draknek)
 *   email                : ezconvert@draknek.org
 *
 *   purpose              : parses the ezBoard topics
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
   die("Hacking attempt");

if (!defined('EZCONVERT_CONFIGURED'))
   fatal_error('Settings not configured');

// conversion from EZBOARD to PHPBB takes place in 5 stages
// Stage 2 parses the individual ezboard topics plus corresponding postings.
//
// The topics are processed starting with the oldest topics/postings first.

// Modified JT - If a topic is marked sticky, set it sticky in the database

if ($config['index_posts'])
{
	include($phpbb_root_path . 'includes/functions_search.' . $phpEx);
}

$forum_id = $config['forum_id'];

$sql = "SELECT * FROM " . EZBOARD_CONVERSION . " WHERE forum_id=$forum_id";
$result = exec_sql ($sql);
if ($db->sql_numrows ($result) == 0)
{
    fatal_error ("No topics were found in stage 1");
}

$sql = "SELECT * FROM " . EZBOARD_CONVERSION . " WHERE forum_id=$forum_id AND topic_locked = 0 AND phpbb_topic < 0 ORDER BY topic_lastpost";
$result = exec_sql ($sql);

// Each topic involves parsing one or multiple ezboard pages. As this will take a long time
// the script is invoked repeatedly to prevent timeouts

for ($i = 0; check_execution_time () && ($row=$db->sql_fetchrow($result)) && $i < 100; $i++)
   {
       $topic_title = $row["topic_title"];
       notice("Processing topic $topic_title...");

	   $ezboard_topic = $row["ezboard_topic"];
       $replies = $row["topic_replies"];
	   $views = $row["topic_views"];
       $topic_poster = $row["topic_poster"];
// Begin sticky modifications
       $sticky = ($row['topic_sticky'] ? POST_STICKY : POST_NORMAL);
       $sql = "INSERT INTO " . TOPICS_TABLE . " (forum_id, topic_title, topic_poster, topic_time, topic_views, topic_replies, topic_status, topic_type, topic_first_post_id, topic_last_post_id, topic_moved_id) ".
              "VALUES ($forum_id, '" . str_replace("'", "''", $topic_title) . "', $topic_poster, 0, $views, $replies, 0, $sticky, 0, 0, 0)";
// End sticky modifications
       exec_sql ($sql);
       $phpbb_topic = $db->sql_nextid();
       $sql = "UPDATE " . EZBOARD_CONVERSION . " SET phpbb_topic=$phpbb_topic WHERE forum_id=$forum_id AND ezboard_topic=$ezboard_topic";
       exec_sql ($sql);
       for ($start=1, $cnt=1; $replies >= 0; $start += 20)
       {
           $cnt=parse_topic ($ezboard_topic, $phpbb_topic, $start);
           $replies -= 20;
       }
   }
   if ($i == $db->sql_numrows ($result) )
   {
      next_stage();
   }
   else
   {
      reload ();
   }
?>
