<?php
/***************************************************************************
 *                            admin_ezconvert.php
 *                            -------------------
 *   begin                : Sunday, 22 July 2002
 *   author               : Rob Bellaart
 *   email                : bellaart@ghanaweb.com
 *
 *   modified             : Monday, 13 January 2003
 *   author               : Chris Burke
 *   email                : serotonin@earthlink.net
 *
 *   modified             : Monday, 07 July 2003
 *   author               : Jamie Tatum
 *   email                : jt@killsdead.com
 *
 *   modified             : Saturday, 19 June 2004
 *   author               : Alan Hazelden (Draknek)
 *   email                : ezconvert@draknek.org
 *
 *   purpose              : reorders posts in the phpBB database
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
   die("Hacking attempt");

if (!defined('EZCONVERT_CONFIGURED'))
   fatal_error('Settings not configured');

// After parsing the ezboard topics in stage 2, the ezboard posts are stored in the wrong order in phpbb;
// the topics from ezboard have a higher posting number while in effect they are (probably) 
// older postings. Consequently these ezboard postings will be shown before more recent postings which were 
// already in the phpbb database
// This routine sorts the posts in the correct order by assigning higher posting-ids

$forum_id = $config['forum_id'];

$sql = "SELECT MAX(A.post_time) AS TIJD FROM " . POSTS_TABLE . " A, " . EZBOARD_CONVERSION . " B WHERE A.topic_id=B.phpbb_topic AND A.forum_id=$forum_id";
$result = exec_sql ($sql);
$row = $db->sql_fetchrow($result);
$max_post_time = $row['TIJD'];

$sql = "SELECT MAX(post_id) AS CNT FROM " . POSTS_TABLE;
$result = exec_sql ($sql);
$row = $db->sql_fetchrow($result);
$new_post_id=$row['CNT'] + 1;

$sql = "SELECT post_id, topic_id FROM " . POSTS_TABLE . " WHERE post_time > $max_post_time AND forum_id=$forum_id ORDER BY post_time";
$result = exec_sql ($sql);

// Draknek - should we be checking timeout here?

for ($cnt = 0; ($row=$db->sql_fetchrow($result)); $cnt++, $new_post_id++)
{
    $topic_id = $row["topic_id"];
    $post_id = $row["post_id"];
    $sql = "UPDATE " . POSTS_TABLE . " SET post_id=$new_post_id WHERE post_id=$post_id";
    exec_sql ($sql);
    $sql = "UPDATE " . POSTS_TEXT_TABLE . " SET post_id=$new_post_id WHERE post_id=$post_id";
    exec_sql ($sql);
    
    // Draknek - does including the WHERE forum_id, topic_id stuff speed it up or slow it down? It's not necessary.
    $sql = "UPDATE " . TOPICS_TABLE . " SET topic_last_post_id=$new_post_id WHERE forum_id=$forum_id ".
           "AND topic_id=$topic_id AND topic_last_post_id=$post_id";
    exec_sql ($sql);               
    $sql = "UPDATE " . TOPICS_TABLE . " SET topic_first_post_id=$new_post_id WHERE forum_id=$forum_id ".
           "AND topic_id=$topic_id AND topic_first_post_id=$post_id";
    exec_sql ($sql);
    
    // Draknek - need to change these as well:
       # forum_last_post_id in phpbb_forums - or maybe not. It's dealt with in next stage
       # post_id in phpbb_search_wordmatch
       # topic_moved_id in phpbb_topics
}

if ($cnt == $db->sql_numrows($result))
{
    next_stage();
}
else
{
  reload();
}

?>
